 ####################################
#     -------------------------      # 
#     AEON IMPROVED ASF FIGHTER      #
#     -------------------------      #
#                                    #
#            Author: BigO            #
#                                    #
 ####################################

##Dont remove these, otherwise OnKilled wont work 
local AAirUnit = import('/lua/aeonunits.lua').AAirUnit
local AirUnit = import('/lua/defaultunits.lua').AirUnit
local MobileUnit = import('/lua/defaultunits.lua').MobileUnit
local Unit = import('/lua/sim/unit.lua').Unit
local AAAAutocannonQuantumWeapon = import('/lua/aeonweapons.lua').AAAAutocannonQuantumWeapon
local AAAZealotMissileWeapon = import('/lua/aeonweapons.lua').AAAZealotMissileWeapon
local Shield = import('/lua/shield.lua').Shield



UAA0303 = Class(AAirUnit) {
    Weapons = {
  
        AutoCannon1 = Class(AAAAutocannonQuantumWeapon) {
        
        
        #########################
        #                       #
        #   When Weapon Fires   #
        #                       #
        #########################
	   
	   OnWeaponFired = function(self)
               AAAAutocannonQuantumWeapon.OnWeaponFired(self)
               
               
	       local me = self.unit:GetBlueprint()
	       
	       if self:GetCurrentTarget() and not me.Thread then
	       
		       local target = self:GetCurrentTarget():GetBlueprint()

	           #--------------#
	           #-Speed Values-#	
	           #--------------#
	           
		       local mySpeed = me.Air.MaxAirspeed
		       local targetSpeed = target.Air.MaxAirspeed


	           #-------------------------------------#		                        
	           #-Percent to use for Speed Multiplier-#   
	           #-------------------------------------#  
		       
		       ##Default Value
		       local speedPercent = 1
		       
	           ##-----------------------------------------------------------------------------
	           ## This IF block ensures that a plane can never go BELOW its minimum speed when
	           ## trying to match its target's speed
	           ##-----------------------------------------------------------------------------
		       
		       if targetSpeed < me.Air.MinAirspeed then
		           
		               speedPercent = me.Air.MinAirspeed/mySpeed
		               
		       else
		      
		               speedPercent = targetSpeed/mySpeed
		       end

		       
	           ##------------------------------------------------------------------------------------------
	           ## This IF block ensures that our plane will never go ABOVE its Maximum Speed when chasing a 
	           ## target ( i.e. when a t1 interceptor is chasing a t3 Air Sup fighter )
	           ##------------------------------------------------------------------------------------------
 
		       if speedPercent < 1 then
		             
			       self.unit:SetSpeedMult(speedPercent)
				   
		       end      
		       
	       end	      
	       
		       
	   end,
	   
	                                         
	                                         
	   
        #########################
        #                       #
        #  When Target is Lost  #
        #                       #
        #########################
       
           OnLostTarget = function(self)
               AAAAutocannonQuantumWeapon.OnLostTarget(self)          
               
                           
                local me = self.unit      
               
             ##------------------------------------------------------------------------------
             ## waitnow() - This function first waits 1 Second after the kill, 
             ##             then reverts the plane back to default speed if its still alive                          
             ##------------------------------------------------------------------------------
             
                waitnow = function(self)
               
	                WaitSeconds(1)

		        if not me:IsDead() and not me.Thread then me:SetSpeedMult(1)  end  	      
                 
                end
               
               
             ##----------------------------
             ## Execute waitnow() Function
             ##----------------------------
               
                me:ForkThread(waitnow)      
	       
	       
	       

	   end,   
	},
	
	
	
	
        TheZealot = Class(AAAZealotMissileWeapon){ 
        
            #the speed code isnt necessary here for the missile weapons as it fires once every 15 seconds
            
        },	
        
       
    },
    
-- *************************************************************************************************************** --
 
 
                                        #############################
    					#                           #
    					#       AfterBurners        #
    					#                           #
					############################# 
					
    ## Activate afterburners if Damage is more than 20 AND plane has enough fuel
    ## Plane bascially gets a 3x boost to its speed/acc/turn stats
    ## Reverts back to default values after 2 seconds
					
  
OnDamage = function(self, instigator, amount, vector, damageType)
            --TAirUnit:OnDamage(self, instigator, amount, vector, damageType)
          
             --Just a reference
            local s = self
            
            
             
            
        ##----------------------##
        ##   Apply the Damage   ##
        ##----------------------##     
        
             if self.CanTakeDamage then
                if self.ShieldIsOn(self) then
                        self:DoOnDamagedCallbacks(instigator)
	                self:DoTakeDamage(instigator, 0, vector, damageType)
                
                else  --if Shield is OFF
	                self:DoOnDamagedCallbacks(instigator)
	                self:DoTakeDamage(instigator, amount, vector, damageType)
	        end
	     end

            
           
            
	##-------------------------------##
	##  Initialze Global Variables   ##   ONLY DONE ON FIRST TIME!
	##-------------------------------##  
	
            ## numOfHits (Number of Times Hit since last Afterburn) ##
            
            if s.numOfHits == nil then
               s.numOfHits = 0
            end
            
            
            ## dmgAccumlated (Amt of dmg sustained since last Afterburn) ##
            
            if s.dmgAccumulated == nil then
               s.dmgAccumulated = 0
            end
 	
 	
 	
 	##--------------------------------##
	##  Update the Global Variables   ##   DONE EVERY TIME !!
	##--------------------------------##            
                 
            s.numOfHits = s.numOfHits + 1
            s.dmgAccumulated = s.dmgAccumulated + amount
            
            
            
	 ##------------------------------------------------------------------------------------##
	 ## DO ONLY if (Plane has Fuel) AND (Not Afterburning Now) AND (Meets Damage Criteria) ##
	 ##------------------------------------------------------------------------------------##  
            
            if s.Thread == nil and s:GetFuelRatio() > 0  then
               if s.dmgAccumulated >= 60 or s.numOfHits >= 6 then        
                                                    
	
		 ##---------------------------##
		 ## Reset my Global Variables ##
		 ##---------------------------##
                    s.numOfHits = 0
                    s.dmgAccumulated = 0	    		
		    
                 ##----------------------##
                 ## Speed/Acc/Turn Boost ##
                 ##----------------------##
                 
		    self:SetSpeedMult(3)    	
		    self:SetAccMult(3)
		    self:SetTurnMult(3)
	
                 ##----------------------------##
                 ## Afterburner Exhaust Effect ##
                 ##----------------------------##
                 
		    CreateAttachedEmitter( self, 'Exhaust_Right', self:GetArmy(), '/effects/emitters/dirty_exhaust_smoke_01_emit.bp')
		  
		 
		 ##------------------------------##
		 ## Revert Stats and Update Fuel ##
                 ##------------------------------##
                 
		   updateSpeedAndFuel = function(self)
		    
		             local preBurnFuel = s:GetFuelRatio() 
				
			     WaitSeconds(2)	                                
			     
			     if not s:IsDead() then
			     
				     local postBurnFuel = s:GetFuelRatio() 
				     
				     local newFuelRatio = preBurnFuel - (3*(preBurnFuel - postBurnFuel))	
				  
				     if newFuelRatio > 0 then
				 
					   s:SetSpeedMult(1) 
					   s:SetAccMult(1)
					   s:SetTurnMult(1)
					   s:SetFuelRatio(newFuelRatio)
					   
				     else 
				        
				          s:SetSpeedMult(0.25) 
					  s:SetAccMult(0.25)
					  s:SetTurnMult(0.25)
					  s:SetFuelRatio(0)
					  s:OnRunOutOfFuel(s)
				         
				     end
			     end
			     
			     WaitSeconds(1)
			     
			     s.Thread = nil     ##Permit next afterburn
			     
				
		    end  
		    
		    
		 ##---------------------------##
		 ## Execute the Actual Update ##
                 ##---------------------------##		    
		    s.Thread = self:ForkThread(updateSpeedAndFuel) 		    
		  
		    	    
		    
               end
            end        
           
    end,    
    
				    ##-------------------------------------------## 
######################################  THIS IS SPECIFICALLY FOR SHIELD AEON ASF ############################################   
				    ##-------------------------------------------## 
				    
## Unit doesnt consider it "Damage" if weapon hits a shield. So OnDamage is never called if a shield is on. 
## Luckily, the two functions below are called whenever the unit is "hit", regardless of shield or not. 
## So we use them to trigger the OnDamage() if the shield is on. 

    
##--------------------------------## 
##   FOR REGULAR PROJECTILE HITS  ##
##--------------------------------## 
        
      OnCollisionCheck =  function(self, other, firingWeapon)      
         
           
           
    	##--------------------------------------## 
    	##  Execute OnDamage() when shield hit  ##
    	##--------------------------------------## 
    	     
    	     ## Doesnt seem to be a way to get a handle on the weapon used
    	     ## So we'll assume that the damage was 20
    	     
    	     if self:ShieldIsOn(self) then
	             self:OnDamage(self, 0, 20, 0, 0)
             end
        
    	##--------------------------------##
    	##     DO Rest of Original Code   ##
    	##--------------------------------##    
    	
    	     if self.DisallowCollisions then
		     return false
	     end
		          
	     if EntityCategoryContains(categories.PROJECTILE, other) then
	         if self:GetArmy() == other:GetArmy() then
		      return other:GetCollideFriendly()
	         end
	     end
	     
	     return true
            
        
        end,
        
##---------------------------------## 
## FOR LASER/INSTA-HIT WEAPON HITS ##
##---------------------------------## 
        
      OnCollisionCheckWeapon = function(self, firingWeapon) 
      

        
         
    	##--------------------------------------## 
    	##  Execute OnDamage() when shield hit  ##
    	##--------------------------------------## 
    	
    	      if self:ShieldIsOn(self) then   
		      self:OnDamage(self, 0, firingWeapon:GetDamageTable(firingWeapon).DamageAmount, 0, 0)
              end
    	    
            
    	##--------------------------------##
    	##     DO Rest of Original Code   ##
    	##--------------------------------## 
    	      if self.DisallowCollisions then
		      return false
	      end
		        
              local collide = firingWeapon:GetBlueprint().CollideFriendly
	      if collide == false then
		    if self:GetArmy() == firingWeapon.unit:GetArmy() then
			return false
		    end
	      end
	      
              return true
           
       
   end,
   
   
######################################################################################################
    
    
					#############################
					#                           #
					#       Trail of Fire       #
					#                           #
					############################# 
					
   #// Spawns a trail of fire from the plane when killed
   
    OnKilled = function(self, instigator, type, overkillRatio)
              AAirUnit.OnKilled(self, instigator, type, overkillRatio)

	 ##----------------------------##
	 ##     Fiery Death Effect     ##
	 ##----------------------------##     
	 
               CreateAttachedEmitter( self, 'Exhaust_Left', self:GetArmy(), '/effects/emitters/flamethrower_emit.bp')
 

    end,    
    
    
    
    
   
    
    
    
}

TypeClass = UAA0303