 ##################################
#     ------------------------     # 
#     UEF IMPROVED T1 FIGHTER      #
#     ------------------------     #
#                                  #
#           Author: BigO           #
#                                  #
 ##################################

local TAirUnit = import('/lua/terranunits.lua').TAirUnit
local TAirToAirLinkedRailgun = import('/lua/terranweapons.lua').TAirToAirLinkedRailgun

UEA0102 = Class(TAirUnit) {
    PlayDestructionEffects = true,
    DamageEffectPullback = 0.25,
    DestroySeconds = 7.5,

    Weapons = {
        LinkedRailGun = Class(TAirToAirLinkedRailgun) {
        
        #########################
        #                       #
        #   When Weapon Fires   #
        #                       #
        #########################
	   
	   OnWeaponFired = function(self)
               TAirToAirLinkedRailgun.OnWeaponFired(self)
               
               
	       local me = self.unit:GetBlueprint()
	       
	       if self:GetCurrentTarget() and self.unit:GetFuelRatio() > 0 then
	       
		       local target = self:GetCurrentTarget():GetBlueprint()

	           #--------------#
	           #-Speed Values-#	
	           #--------------#
	           
		       local mySpeed = me.Air.MaxAirspeed
		       local targetSpeed = target.Air.MaxAirspeed


	           #-------------------------------------#		                        
	           #-Percent to use for Speed Multiplier-#   
	           #-------------------------------------#  
		       
		       ##Default Value
		       local speedPercent = 1
		       
	           ##-----------------------------------------------------------------------------
	           ## This IF block ensures that a plane can never go BELOW its minimum speed when
	           ## trying to match its target's speed
	           ##-----------------------------------------------------------------------------
		       
		       if targetSpeed < me.Air.MinAirspeed then
		           
		               speedPercent = me.Air.MinAirspeed/mySpeed
		               
		       else
		      
		               speedPercent = targetSpeed/mySpeed
		       end

		       
	           ##------------------------------------------------------------------------------------------
	           ## This IF block ensures that our plane will never go ABOVE its Maximum Speed when chasing a 
	           ## target ( i.e. when a t1 interceptor is chasing a t3 Air Sup fighter )
	           ##------------------------------------------------------------------------------------------
 
		       if speedPercent < 1 then
		             
			       self.unit:SetSpeedMult(speedPercent)
				   
		       end      
		       
	       end	      
	       
		       
	   end,
	   
	                                         
	                                         
	   
        #########################
        #                       #
        #  When Target is Lost  #
        #                       #
        #########################
       
           OnLostTarget = function(self)
               TAirToAirLinkedRailgun.OnLostTarget(self)          
               
                           
                local me = self.unit      
               
             ##------------------------------------------------------------------------------
             ## waitnow() - This function first waits 1 Second after the kill, 
             ##             then reverts the plane back to default speed if its still alive                          
             ##------------------------------------------------------------------------------
             
                waitnow = function(self)
               
	                WaitSeconds(1)

		        if not me:IsDead() and me:GetFuelRatio() > 0 then me:SetSpeedMult(1)  end  	      
                 
                end
               
               
             ##----------------------------
             ## Execute waitnow() Function
             ##----------------------------
               
                self:ForkThread(waitnow)      
	       
	       
	       

	   end,           
        },
    },
}

TypeClass = UEA0102