 ###################################
#     ------------------------      # 
#     UEF IMPROVED ASF FIGHTER      #
#     ------------------------      #
#                                   #
#           Author: BigO            #
#                                   #
 ###################################


##Dont remove these, otherwise OnKilled wont work 
local TAirUnit = import('/lua/terranunits.lua').TAirUnit
local AirUnit = import('/lua/defaultunits.lua').AirUnit
local MobileUnit = import('/lua/defaultunits.lua').MobileUnit
local TDFMachineGunWeapon = import('/lua/terranweapons.lua').TDFMachineGunWeapon
local TSAMLauncher = import('/lua/terranweapons.lua').TSAMLauncher


UEA0303 = Class(TAirUnit) {
    Weapons = {
     
						############################
						#                          #
						#     THE MACHINE GUN      #
						#                          #
						############################       
   
        HeavyMG = Class(TDFMachineGunWeapon) {      
        
        
        #########################
        #                       #
        #   When Weapon Fires   #
        #                       #
        #########################
	   
	   OnWeaponFired = function(self)
               TDFMachineGunWeapon.OnWeaponFired(self)
               
               
	       local me = self.unit:GetBlueprint()
	       
	       if self:GetCurrentTarget() and not me.Thread then
	       
		       local target = self:GetCurrentTarget():GetBlueprint()

	           #--------------#
	           #-Speed Values-#	
	           #--------------#
	           
		       local mySpeed = me.Air.MaxAirspeed
		       local targetSpeed = target.Air.MaxAirspeed


	           #-------------------------------------#		                        
	           #-Percent to use for Speed Multiplier-#   
	           #-------------------------------------#  
		       
		       ##Default Value
		       local speedPercent = 1
		       
	           ##-----------------------------------------------------------------------------
	           ## This IF block ensures that a plane can never go BELOW its minimum speed when
	           ## trying to match its target's speed
	           ##-----------------------------------------------------------------------------
		       
		       if targetSpeed < me.Air.MinAirspeed then
		           
		               speedPercent = me.Air.MinAirspeed/mySpeed
		               
		       else
		      
		               speedPercent = targetSpeed/mySpeed
		       end

		       
	           ##------------------------------------------------------------------------------------------
	           ## This IF block ensures that our plane will never go ABOVE its Maximum Speed when chasing a 
	           ## target ( i.e. when a t1 interceptor is chasing a t3 Air Sup fighter )
	           ##------------------------------------------------------------------------------------------
 
		       if speedPercent < 1 then
		             
			       self.unit:SetSpeedMult(speedPercent)
				   
		       end      
		       
	       end	      
	       
		       
	   end,
	   
	                                         
	                                         
	   
        #########################
        #                       #
        #  When Target is Lost  #
        #                       #
        #########################
       
           OnLostTarget = function(self)
               TDFMachineGunWeapon.OnLostTarget(self)          
               
                           
                local me = self.unit      
               
             ##------------------------------------------------------------------------------
             ## waitnow() - This function first waits 1 Second after the kill, 
             ##             then reverts the plane back to default speed if its still alive                          
             ##------------------------------------------------------------------------------
             
                waitnow = function(self)
               
	                WaitSeconds(1)

		        if not me:IsDead() and not me.Thread then me:SetSpeedMult(1)  end  	      
                 
                end
               
               
             ##----------------------------
             ## Execute waitnow() Function
             ##----------------------------
               
                me:ForkThread(waitnow)      
	       
	       
	       

	   end,   
	   
        },     
      
      
      
					#############################
					#                           #
					#  The Sidewinder Missile   #
					#                           #
					#############################             
        
        LeftMissile = Class(TSAMLauncher) {
        
            #the speed code isnt necessary here for the missile weapons as it fires once every 15 seconds
            
        },
    },
    
 -- *************************************************************************************************************** --

 
 
                                        #############################
    					#                           #
    					#       AfterBurners        #
    					#                           #
					############################# 
					
    ## Activate afterburners only if plan has enough fuel AND only if damage accumlated 
    ## is >= 60 or the plane was hit at least 6 times.
    ## Plane bascially gets a 3x boost to its speed/acc/turn stats
    ## Reverts back to default values after 2 seconds, appropriate amount of fuel is deducted
    ## The s.thread = nil parts are to ensure that only one afterburn session can occur at a time
					

  
    OnDamage = function(self, instigator, amount, vector, damageType)
            --TAirUnit:OnDamage(self, instigator, amount, vector, damageType)
            
             --Just a reference
            local s = self
            
        ##----------------------##
        ##   Apply the Damage   ##
        ##----------------------##     
        
             if self.CanTakeDamage then
	                self:DoOnDamagedCallbacks(instigator)
	                self:DoTakeDamage(instigator, amount, vector, damageType)
	     end

            
           
            
	##-------------------------------##
	##  Initialze Global Variables   ##   ONLY DONE ON FIRST TIME!
	##-------------------------------##  
	
            ## numOfHits (Number of Times Hit since last Afterburn) ##
            
            if s.numOfHits == nil then
               s.numOfHits = 0
            end
            
            
            ## dmgAccumlated (Amt of dmg sustained since last Afterburn) ##
            
            if s.dmgAccumulated == nil then
               s.dmgAccumulated = 0
            end
 	
 	##--------------------------------##
	##  Update the Global Variables   ##   DONE EVERY TIME !!
	##--------------------------------##            
                 
            s.numOfHits = s.numOfHits + 1
            s.dmgAccumulated = s.dmgAccumulated + amount
            
	 ##--------------------------------------------------------------------------------##
	 ## DO ONLY if (Plane has Fuel) AND (Not Afterburning) AND (Meets Damage Criteria) ##
	 ##--------------------------------------------------------------------------------##  
            if s.Thread == nil and s:GetFuelRatio() > 0  then
               if s.dmgAccumulated >= 60 or s.numOfHits >= 6 then        
                                                    
	
		 ##---------------------------##
		 ## Reset my Global Variables ##
		 ##---------------------------##
                    s.numOfHits = 0
                    s.dmgAccumulated = 0	    		
		    
                 ##----------------------##
                 ## Speed/Acc/Turn Boost ##
                 ##----------------------##
                 
		    self:SetSpeedMult(3)    	
		    self:SetAccMult(3)
		    self:SetTurnMult(3)
	
                 ##----------------------------##
                 ## Afterburner Exhaust Effect ##
                 ##----------------------------##
                 
		    CreateAttachedEmitter( self, 'Exhaust', self:GetArmy(), '/effects/emitters/dirty_exhaust_smoke_01_emit.bp')
		  
		 
		 ##------------------------------##
		 ## Revert Stats and Update Fuel ##
                 ##------------------------------##
                 
		   updateSpeedAndFuel = function(self)
		    
		             local preBurnFuel = s:GetFuelRatio() 
				
			     WaitSeconds(2)	                                
			     
			     if not s:IsDead() then
			     
				     local postBurnFuel = s:GetFuelRatio() 
				     
				     local newFuelRatio = preBurnFuel - (3*(preBurnFuel - postBurnFuel))	
				  
				     if newFuelRatio > 0 then
				 
					   s:SetSpeedMult(1) 
					   s:SetAccMult(1)
					   s:SetTurnMult(1)
					   s:SetFuelRatio(newFuelRatio)
					   
				     else 
				        
				          s:SetSpeedMult(0.25) 
					  s:SetAccMult(0.25)
					  s:SetTurnMult(0.25)
					  s:SetFuelRatio(0)
					  s:OnRunOutOfFuel(s)
				         
				     end
			     end
			     
			     WaitSeconds(1)
			     
			     s.Thread = nil  
			     
				
		    end  
		    
		    
		 ##---------------------------##
		 ## Execute the Actual Update ##
                 ##---------------------------##		    
		    s.Thread = self:ForkThread(updateSpeedAndFuel) 		    
		  
		    
		    
		    
		    
               end
            end         
           
    end,  
                 
		        
    
					#############################
					#                           #
					#       Trail of Fire       #
					#                           #
					############################# 
					
   #// Spawns a trail of fire from the plane when killed
  
    OnKilled = function(self, instigator, type, overkillRatio)
                TAirUnit.OnKilled(self, instigator, type, overkillRatio)
              
              

	 ##----------------------------##
	 ##     Fiery Death Effect     ##
	 ##----------------------------##  
        CreateAttachedEmitter( self, 'Exhaust', self:GetArmy(), '/effects/emitters/flamethrower_emit.bp')


    end,
    
    
    
   --[[  THIS IS FOR TESTING PURPOSES ONLY     
                if s.variable == nil then
                s.variable = 0
                end
                s.variable = s.variable + 1
                
             LOG('hit# ' .. s.variable)      
             LOG('CurrentRatio= ' .. s:GetFuelRatio()) 
             LOG('damage= ' .. s.dmgAccumulated)  
     	LOG('timesHit= ' .. s.numOfHits)
   --]] 
    
}

TypeClass = UEA0303