 ###################################
#     ---------------------------   # 
#     CYBRAN IMPROVED T1 FIGHTER    #
#     ---------------------------   #
#                                   #
#           Author: BigO            #
#                                   #
 ###################################

local CAirUnit = import('/lua/cybranunits.lua').CAirUnit
local CAAAutocannon = import('/lua/cybranweapons.lua').CAAAutocannon

URA0102 = Class(CAirUnit) {
    Weapons = {
        AutoCannon = Class(CAAAutocannon) {
        #########################
        #                       #
        #   When Weapon Fires   #
        #                       #
        #########################
	   
	   OnWeaponFired = function(self)
               CAAAutocannon.OnWeaponFired(self)
               
               
	       local me = self.unit:GetBlueprint()
	       
	       if self:GetCurrentTarget() and self.unit:GetFuelRatio() > 0 then
	       
		       local target = self:GetCurrentTarget():GetBlueprint()

	           #--------------#
	           #-Speed Values-#	
	           #--------------#
	           
		       local mySpeed = me.Air.MaxAirspeed
		       local targetSpeed = target.Air.MaxAirspeed


	           #-------------------------------------#		                        
	           #-Percent to use for Speed Multiplier-#   
	           #-------------------------------------#  
		       
		       ##Default Value
		       local speedPercent = 1
		       
	           ##-----------------------------------------------------------------------------
	           ## This IF block ensures that a plane can never go BELOW its minimum speed when
	           ## trying to match its target's speed
	           ##-----------------------------------------------------------------------------
		       
		       if targetSpeed < me.Air.MinAirspeed then
		           
		               speedPercent = me.Air.MinAirspeed/mySpeed
		               
		       else
		      
		               speedPercent = targetSpeed/mySpeed
		       end

		       
	           ##------------------------------------------------------------------------------------------
	           ## This IF block ensures that our plane will never go ABOVE its Maximum Speed when chasing a 
	           ## target ( i.e. when a t1 interceptor is chasing a t3 Air Sup fighter )
	           ##------------------------------------------------------------------------------------------
 
		       if speedPercent < 1 then
		             
			       self.unit:SetSpeedMult(speedPercent)
				   
		       end      
		       
	       end	      
	       
		       
	   end,
	   
	                                         
	                                         
	   
        #########################
        #                       #
        #  When Target is Lost  #
        #                       #
        #########################
       
           OnLostTarget = function(self)
               CAAAutocannon.OnLostTarget(self)          
               
                           
                local me = self.unit      
               
             ##------------------------------------------------------------------------------
             ## waitnow() - This function first waits 1 Second after the kill, 
             ##             then reverts the plane back to default speed if its still alive                          
             ##------------------------------------------------------------------------------
             
                waitnow = function(self)
               
	                WaitSeconds(1)

		        if not me:IsDead() and me:GetFuelRatio() > 0 then me:SetSpeedMult(1)  end  	      
                 
                end
               
               
             ##----------------------------
             ## Execute waitnow() Function
             ##----------------------------
               
                self:ForkThread(waitnow)      
	       
	       
	       

	   end,             
        
        },
        AutoCannon2 = Class(CAAAutocannon) {},
    },
}

TypeClass = URA0102